import { ViewBase } from '../../libappbase/viewbase';
import { UIWaitSOP } from '../../libappsop/objectsop';
import { ButtonProcessesContextMenuItem } from '../actionbarpages/abp.data';
import { AppMP } from '../appmp';
import { FormCampaignTypes } from '../forms/form.campaigntypes';
import { FormTransitionTypes } from '../forms/form.transitiontypes';

export class ViewCampaignsAndTransitions extends ViewBase implements UIWaitSOP {
  public readonly name = 'Campaigns & Transitions';
  public readonly viewPath = `Data > Processes > ${this.name}`;

  public formCampaignTypes = new FormCampaignTypes();
  public formTransitionTypes = new FormTransitionTypes();

  public async switchTo(): Promise<void> {
    const appMP = AppMP.getInstance();
    // Click Data action bar page
    await appMP.abpData.click();
    // Click on Processes dropdown button and select Campaigns & Transitions item
    await appMP.abpData.btnProcesses.clickDropdownAndSelectMenu(ButtonProcessesContextMenuItem.CampaignsAndTransitions);
    await this.waitUILoaded();
  }

  public async waitUILoaded(): Promise<void> {
    await this.formCampaignTypes.waitUntilPresent();
  }
}
